"use strict"
let forAwaitTemplate = String.raw`
async function x() {
    let ITERATOR;
    let ITERABLE = ITERABLEXPRESSION;
    if (ITERABLE[Symbol.asyncIterator]) {
        ITERATOR = ITERABLE[Symbol.asyncIterator]();
    } else if (ITERABLE[Symbol.iterator]) {
        ITERATOR = ITERABLE[Symbol.iterator]();
    } else {
        ITERATOR = ITERABLE[Symbol.asyncIterator]();
    };

    while (true) {
        let {done: DONEID, value: VALUEID} = await ITERATOR.next();
        if (DONEID) {
            break;
        }
        ASSIGNTARGET = await VALUEID;
        BODY
    }
};
`

module.exports = function(babel) {
    console.log("Called");
    return {
        visitor: {
            ForAwaitStatement(node, parent) {
                let replacer = babel.template(forAwaitTemplate);
                let nodes = replacer({
                    // Setup variables
                    ITERATOR: node.generateUidIdentifier("iterator"),
                    ITERABLE: node.generateUidIdentifier("iterable"),
                    DONEID: node.generateUidIdentifier("done"),
                    VALUEID: node.generateUidIdentifier("value"),
                    // And add the actual code
                    ASSIGNTARGET: node.left,
                    ITERABLEEXPRESSION: node.right,
                    BODY: node.body
                });
                return nodes;
            }
        }
    }
}
